<template>
	<div>
		<div class="cards">
			<h4>Anfragen</h4>
			<div class="card-body b-gap-1">
				<div class="cell">
					<custom-switch @clicked="globalToggleDeleteButtons" />
					L&ouml;schen
				</div>

				<div class="cols c-0-1">
					<template v-for="request in requestsPaginated">
						<div :key="'col1-' + request.id" class="cell button-row--icons">
							<button ref="delete" @click="deleteRequest(request.id)" class="button button--close" disabled></button>
							<router-link :to="'/admin/requests/detail/' + request.id" ref="edit" class="button button--details"></router-link>
						</div>
						<div :key="'col2-' + request.id" class="cell bg-4">{{ request.name }}</div>
					</template>
				</div>
			</div>

			<paginator @clicked="fetchRequestsPaginated" :limiter="2" :total-pages="totalPages" :current-page="currentPage" />

		</div>

		<loader v-if="isLoading" />

		<system-message v-if="sysMsg" :msg.sync="sysMsg" />
	</div>
</template>

<script>
import CustomSwitch from "@/components/buttons/CustomSwitch";
import SystemMessage from "@/components/SystemMessage";
import Loader from "@/components/Loader";
import axios from "axios";
import Paginator from "@/components/Paginator";

export default {
	name: "AdminRequests",
	components: {
		Paginator,
		Loader,
		CustomSwitch,
		SystemMessage
	},
	data: () => ({
		isLoading: false,
		requestsPaginated: {},
		totalPages: 0,
		currentPage: 1,
		sysMsg: undefined
	}),
	methods: {
		async fetchRequestsPaginated(page = 1) {
			try {
				this.isLoading = true;
				const response = await axios.get("/api/admin/requests/list/" + page);
				this.currentPage = page;
				this.totalPages = response.data.totalPages;
				this.requestsPaginated = response.data.paginatedContent;
				this.isLoading = false;
			} catch (e) {
				console.error(e);
			}
		},
		async deleteRequest(id) {
			this.sysMsg = "";
			try {
				this.isLoading = true;
				const response = await this.$http.delete("/api/admin/requests/delete/" + id);
				switch (response.status) {
					case 200:
						await this.fetchRequestsPaginated();
						this.sysMsg = "Anfrage erfolgreich gelöscht!";
						break;
				}
				this.isLoading = false;
			} catch (e) {
				console.error(e);
			}
		}
	},
	computed: {
/*
		allRequests() {
			return this.$store.getters.getAllRequests;
		}
*/
	},
	mounted() {
/*
		this.isLoading = true;
		this.$store.dispatch("getAllRequests").then(() => this.isLoading = false);
*/
		this.fetchRequestsPaginated();
	}
}
</script>

<style scoped>

</style>